SW = LibStub("AceAddon-3.0"):NewAddon("Shaman Warning", "AceEvent-3.0", "AceConsole-3.0")

local options = {
	name = "ShamanWarning",
	handler = SW,
	type = "group",
	args = {
		elemental = {
			name = "Elemental Devastation",
			desc = "Toggles on/off Elemental Devastation proc warning",
			type = 'toggle',
			get = "IsElemental",
			set = "ToggleElemental",
		},
		windfury = {
			name = "WindFury",
			desc = "Toggles on/off Windfury proc warning",
			type = 'toggle',
			get = "IsWindfury",
			set = "ToggleWindfury",
		},
		flurry = {
			name = "Flurry",
			desc = "Toggles on/off Flurry proc warning",
			type = 'toggle',
			get = "IsFlurry",
			set = "ToggleFlurry",
		},
		storm = {
			name = "Eye of the Storm",
			desc = "Toggles on/off Eye of the Storm proc warning",
			type = 'toggle',
			get = "IsStorm",
			set = "ToggleStorm",
		},
		water = {
			name = "Water Shield",
			desc = "Toggles on/off Water Shield removed warning",
			type = 'toggle',
			get = "IsWater",
			set = "ToggleWater",
		},
		clearcast = {
			name = "Clearcasting",
			desc = "Toggles on/off clearcasting proc warning",
			type = 'toggle',
			get = "IsClearcast",
			set = "ToggleClearcast",
		},
	},
}

local defaults = {
	profile = {
		elemental = true,
		windfury = true,
		flurry = true,
		storm = true,
		water = true,
		clearcast = true,
	},
}

function SW:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("ShamanWarningDB", defaults, "Default")
	LibStub("AceConfig-3.0"):RegisterOptionsTable("ShamanWarning", options)
	optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("ShamanWarning", "ShamanWarning")
	self:RegisterChatCommand("sw", "ChatCommand")
end;

function SW:OnEnable()
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED","CombatLogEvent")
end;

function SW:CombatLogEvent(a, timestamp, event, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, spellID, spellName)
	if event=="SPELL_AURA_APPLIED" and destFlags==0x511 then
		if spellName=="Flurry" and self.db.profile.flurry then
			PlaySoundFile("Interface\\AddOns\\ShamanWarning\\Sounds\\Flurry.mp3")
		end;
		if (spellName=="Clearcasting" or spellName=="Focused") and self.db.profile.clearcast then
			PlaySoundFile("Interface\\AddOns\\ShamanWarning\\Sounds\\Clearcast.mp3")
		end;
		if spellName=="Elemental Devastation" and self.db.profile.elemental then
			PlaySoundFile("Interface\\AddOns\\ShamanWarning\\Sounds\\Elemental.mp3")
		end;
		if spellName=="Focused Casting" and self.db.profile.storm then
			PlaySoundFile("Interface\\AddOns\\ShamanWarning\\Sounds\\Storm.mp3")
		end;
	end;
	if event=="SPELL_AURA_REMOVED" and destFlags==0x511 then
		if spellName=="Water Shield" and self.db.profile.water then
			PlaySoundFile("Interface\\AddOns\\ShamanWarning\\Sounds\\Water.mp3")
		end;
	end;
	if event=="SPELL_DAMAGE" and sourceFlags==0x511 then
		if spellName=="Windfury Attack" and self.db.profile.windfury then
			PlaySoundFile("Interface\\AddOns\\ShamanWarning\\Sounds\\WindFury.mp3")
		end;
	end;
end;

function SW:IsElemental()
	return self.db.profile.elemental;
end;

function SW:ToggleElemental()
	self.db.profile.elemental = not self.db.profile.elemental;
end;

function SW:IsWindfury()
	return self.db.profile.windfury;
end;

function SW:ToggleWindfury()
	self.db.profile.windfury = not self.db.profile.windfury;
end;

function SW:IsFlurry()
	return self.db.profile.flurry;
end;

function SW:ToggleFlurry()
	self.db.profile.flurry = not self.db.profile.flurry;
end;

function SW:IsStorm()
	return self.db.profile.storm;
end;

function SW:ToggleStorm()
	self.db.profile.storm = not self.db.profile.storm;
end;

function SW:IsWater()
	return self.db.profile.water;
end;

function SW:ToggleWater()
	self.db.profile.water = not self.db.profile.water;
end;

function SW:IsClearcast()
	return self.db.profile.clearcast;
end;

function SW:ToggleClearcast()
	self.db.profile.clearcast = not self.db.profile.clearcast;
end;
